# -*- coding: utf-8 -*-
###########################################################################
# 
# Eole NG
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr 
#  
###########################################################################

"""Utilitaire simplissime de templating
pour generer une instruction %for de cheetah
"""
class Template:
    """genere un template cheetah (syntaxe for)
    en notation creole pointee pour les variables maitre et esclaves
    """
    def __init__(self, master=None, slaves=[], template=""):
        """
        :master: variable maitre au sens creole
        :slaves: liste des variables esclaves
                 a noter que les valeurs multivaluees autres ne peuvent etre
                 que des esclaves (les autres valeurs multiples sont en notation
                 avec des crochets)
        :template: ligne a traiter
        """
        self.template = template
        # la variable maitre ne doit pas etre dans la liste des esclaves
        if master in slaves:
            raise Exception, "une variable maitre est traitee comme une esclave" 
        if master:
            self.master = master
        else:
            raise Exception, "instanciation d'une boucle for et pas de variable maitre dans la ligne"
        self.slaves = slaves

    def __str__(self):
        line = str(self.template % self)
        line = self.wrapwithfor(line)
        return line
    
    def __getitem__(self, key):
        return self._process(key)

    def wrapwithfor(self, line):
        """la ligne passee en parametre est le corps du template
        il reste a la transformer en boucle for au sens cheetah"""
        return """%%for %%%%v in %%%%%s
%s
%%end for""" % (self.master, line)
        
    def _process(self, key):
        if key == self.master:
            return "%%v"
        else:
            return "%%%%v.%s" % key

#def test():
#    "test avec master et slave"
#    print Template(master="name", slaves=["tintin"],
#                   template="Hello %(name)s and %(tintin)s!")
#    """
#    %for v in 
#    Hello %%v and %%v.tintin!
#    %end for
#    """
#    "test sans slave"
#    print Template(master="name", slaves=[],
#                   template="Hello %(name)s!")


