# -*- coding: UTF-8 -*-
###########################################################################
# 
# Eole NG  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr 
#  
###########################################################################
"""
    Controlleur (mvc) au niveau de l'application
"""
import gtk
from era.noyau.path import setup_path
setup_path()
from gtkmvc import Controller

class IncludeCtrl(Controller):
    def __init__(self, model, view):
        Controller.__init__(self, model, view)

    def register_view(self, view):
        text_view = view.text_view
        text_view.set_buffer(self.model.text_buf)

    # ____________________________________________________________
    # values
    def property_rules_value_change(self, model, old, new):
        """
            si les options du xml ont changées, recharger la vue text_buffer
        """
        self.model.init_text_buf()
    # ____________________________________________________________
    # signals
    def on_valid_include_clicked(self, wdgt):
        """
            callback après validation
            
            - ferme la fenêtre 
            - enregistre les rules
        """
        self.view.get_top_widget().hide_all()
        self.save_rules()
        return True
        
    def on_cancel_include_clicked(self, wdgt):
        """
            - fermeture de la fenetre
            
            - réinitialise le text_view
              permet de le remettre comme il était si il a été modifié
              mais pas validé
        """
        self.model.init_text_buf()
        self.view.get_top_widget().hide_all()
        return True

    def on_dialog_include_delete_event(self, wdgt, evnt):
        """
            - fermeture de la fenetre
            
            - réinitialise le text_view
              permet de le remettre comme il était si il a été modifié
              mais pas validé
        """
        self.view.get_top_widget().hide_all()
        self.model.init_text_buf()
        return True
        
    def save_rules(self):
        """
            recuperation du contenu du widget d'edition
        """
        text = self.view.text_view.get_buffer()
        start = text.get_start_iter()
        end = text.get_end_iter()
        self.model.rules = text.get_text(start,end)
 
