# -*- coding: UTF-8 -*-
###########################################################################
# 
# Eole NG  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html
# eole@ac-dijon.fr 
#  
###########################################################################
"""
    Model (mvc) pour les options du xml
"""
import gtk
from era.noyau.path import setup_path
setup_path()
from gtkmvc import Model

class OptionModel(Model):
    """
        Modele des du widget des options et des inclusions statiques
    """
    list_store = gtk.ListStore(str, bool)
    # inclusion statique
    text_buf = gtk.TextBuffer()
    
    def __init__(self):
        Model.__init__(self)
        self.populate_liststore()
        self.init_text_buf()
        
    def init_text_buf(self):
        """
            remplit les inclusions statiques
        """
        if self.rules == None:
            rules = ""
        else:
            rules = str(self.rules)
        self.text_buf.set_text(rules)

    def init_liststore(self):
        self.list_store = gtk.ListStore(str, bool)

    def reload_liststore(self):
        self.init_liststore()
        self.populate_liststore()
                        
    def populate_liststore(self):
        for option in self.options.keys():
            self.list_store.append([option, bool(int(self.options[option]))])

